﻿/* Copyright 2013-present MongoDB Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using MongoDB.Driver.Core.Misc;

namespace MongoDB.Driver.Core.WireProtocol
{
    /// <summary>
    /// Instructions for handling the response from a command.
    /// </summary>
    public enum CommandResponseHandling
    {
        /// <summary>
        /// Return the response from the server.
        /// </summary>
        Return,
        /// <summary>
        /// Ignore the response from the server.
        /// </summary>
        Ignore,
        /// <summary>
        /// No response is expected from the server.
        /// </summary>
        NoResponseExpected
    }
}
