﻿/* Copyright 2010-present MongoDB Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MongoDB.Driver
{
    /// <summary>
    /// Represents an identity defined outside of mongodb.
    /// </summary>
    public class MongoExternalIdentity : MongoIdentity
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MongoExternalIdentity" /> class.
        /// </summary>
        /// <param name="username">The username.</param>
        public MongoExternalIdentity(string username)
            : base("$external", username)
        { }

        /// <summary>
        /// Initializes a new instance of the <see cref="MongoExternalIdentity" /> class.
        /// </summary>
        /// <param name="source">The source.</param>
        /// <param name="username">The username.</param>
        public MongoExternalIdentity(string source, string username)
            : base(source, username)
        { }
    }
}
